<template>
  <!-- 备件仓库 -->
  <el-dialog width="80%" :title="title + '备品库'" :visible="showWarehouseDia" :before-close="formClose"
             v-if="showWarehouseDia">
    <el-form ref="formInfo" :rules="rules" :model="params" label-width="120px">
      <!-- <el-collapse accordion v-model="activeCollapse" class="form-collapse">
        <el-collapse-item name="1">
          <template slot="title">
            <span class="collapse-title">
              <i class="collapse-title-icon el-icon-info"></i>
              备品库基本信息
            </span>
          </template> -->
      <el-row>
        <el-col :span="8">
          <el-form-item prop="warehouseName" label="备品库名称">
            <el-input maxlength="100" show-word-limit placeholder="请输入备品库名称" v-model="params.warehouseName">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item prop="warehouseCode" label="备品库编码">
            <el-input maxlength="100" show-word-limit placeholder="请输入备品库编码" v-model="params.warehouseCode">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item prop="warehouseAddress" label="备品库地址">
            <el-input maxlength="100" show-word-limit placeholder="请输入备品库地址" v-model="params.warehouseAddress">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item label="经度：" prop="longitude">
            <el-input maxlength="32" @input="formatNumber('longitude')" placeholder="请输入经度"
                      v-model="params.longitude"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="纬度：" prop="latitude">
            <el-input maxlength="32" @input="formatNumber('latitude')" placeholder="请输入纬度"
                      v-model="params.latitude"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="备注" prop="memo">
        <el-input maxlength="500" show-word-limit type="textarea" :autosize="{minRows: 3, maxRows: 4}"
                  placeholder="请输入备注内容" v-model="params.memo">
        </el-input>
      </el-form-item>
      <!-- </el-collapse-item>
      <el-collapse-item name="2" v-show="extendParams.length">
        <template slot="title">
          <span class="collapse-title">
            <i class="collapse-title-icon el-icon-circle-plus"></i>
            备品库扩展信息
          </span>
        </template>
        <el-row type="flex" justify="start" style="flex-wrap: wrap; flex-direction: row">
          <el-col :span="extendParam.layout" v-for="extendParam in extendParams" :key="extendParam.id">
            <el-form-item :prop="extendRuleNames[`$extend${extendParam.id}`]" :label="extendParam.name">
              <el-input v-if="extendParam.ctlType == 'input'" :placeholder="`请输入${extendParam.name}`"
                v-model="params[`$extend${extendParam.id}`]"></el-input>
              <el-input v-if="extendParam.ctlType == 'number'" :min="0" type="number"
                :placeholder="`请输入${extendParam.name}`"
                v-model.number="params[`$extend${extendParam.id}`]"></el-input>
              <el-radio-group v-if="extendParam.ctlType == 'radio'"
                :placeholder="`请选择${extendParam.name}`"
                v-model="params[`$extend${extendParam.id}`]">
                <template v-if="extendParam.json">
                  <el-radio v-for="item in JSON.parse(extendParam.json)" :key="item.value"
                    :label="item.value">{{ item.label }}
                  </el-radio>
                </template>
              </el-radio-group>
              <el-checkbox-group v-if="extendParam.ctlType == 'checkbox' && extendParam.json"
                :placeholder="`请选择${extendParam.name}`"
                v-model="params[`$extend${extendParam.id}`]">
                <el-checkbox v-for="item in JSON.parse(extendParam.json)" :key="item.value"
                  :label="item.value">{{ item.label }}
                </el-checkbox>
              </el-checkbox-group>
              <el-select v-if="extendParam.ctlType == 'select'"
                :placeholder="`请选择${extendParam.name}`"
                v-model="params[`$extend${extendParam.id}`]">
                <template v-if="extendParam.json">
                  <el-option v-for="item in JSON.parse(extendParam.json)" :key="item.value"
                    :label="item.label" :value="item.value">
                  </el-option>
                </template>
              </el-select>
              <el-date-picker v-if="extendParam.ctlType == 'date'"
                :placeholder="`请选择${extendParam.name}`" v-model="params[`$extend${extendParam.id}`]"
                value-format="yyyy-MM-dd">
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-collapse-item>
    </el-collapse> -->
    </el-form>
    <span slot="footer" class="dialog-footer">
			<el-button type="primary" @click="handleSave">保 存</el-button>
			<el-button @click="formClose">取 消</el-button>
		</span>
  </el-dialog>
</template>

<script>
import SpareWarehouse from '@/api/device/SpareWarehouse.js'
import latitude from '@/mixins/latitude'
import {
  ExtendParamsMixin
} from '@/mixins/extendParams.js'
import utils from '@/hotent-ui-util.js'

export default {
  name: 'SparePartsWarehouseModal',
  mixins: [ExtendParamsMixin],
  data() {
    return {
      title: '新增',
      showWarehouseDia: false,
      activeCollapse: '1',
      params: {
        warehouseCode: '',
        warehouseName: '',
        warehouseAddress: '',
        memo: '',
        latitude: '',
        longitude: ''
      },
      rules: {
        warehouseAddress: [{
          required: true,
          message: '请输入备品库地址',
          trigger: 'blur'
        }],
        warehouseCode: [{
          required: true,
          message: '请输入备品库编码',
          trigger: 'blur'
        }],
        warehouseName: [{
          required: true,
          message: '请输入备品库名称',
          trigger: 'blur'
        }]
      }
    }
  },
  created() {
    // await this.getExtendParams(5)
  },
  methods: {
    add() {
      this.title = '新增'
      // 扩展字段混入到表单绑定数据中
      // this.handleExtendParamsMixin()
      this.showWarehouseDia = true
    },
    edit(row) {
      this.params = row
      this.title = '修改'
      // 获取扩展字段值
      // await this.getExtendParamsData(5, this.params.id)
      // 扩展字段混入到表单绑定数据中
      // this.handleExtendParamsMixin()
      this.showWarehouseDia = true
    },
    formatNumber(key) {
      console.log(key)
      this.params[key] = latitude.TreeFour(this.params[key])
      // switch (key) {
      //     case 'lgtd':
      //         this.params.longitude = Number(
      //             latitude.TreeFour(this.params.longitude)
      //         )
      //         break
      //     case 'lttd':
      //         this.params.latitude = Number(
      //             latitude.TreeFour(this.params.latitude)
      //         )
      //         break
      //     default:
      //         this.params.latitude = Number(
      //             latitude.TreeFour(this.params.latitude)
      //         )
      // }
    },
    // 备品库弹窗关闭
    formClose() {
      this.params = {
        warehouseCode: '',
        warehouseName: '',
        warehouseAddress: '',
        latitude: '',
        longitude: ''
      }
      this.title = '新增'
      this.activeCollapse = '1'
      this.showWarehouseDia = false
    },
    handleSave() {
      this.$refs.formInfo.validate((valid) => {
        if (valid) {
          // let tempData = utils.deepClone(this.params)
          // 扩展字段提交前预处理数据
          // tempData = this.handleExtendParamsSave(tempData, '5')
          console.log(this.params)
          if (!!this.params.id) {
            SpareWarehouse.modifySpareWarehouse(this.params, (res) => {
              if (res.state) {
                this.$notify({
                  type: 'success',
                  message: '修改成功',
                  duration: 2000
                })
                this.showWarehouseDia = false
                this.$emit('getTreen')
                this.$emit('loadData')
              }
            })
          } else {
            // 添加
            SpareWarehouse.addSpareWarehouse(this.params, (res) => {
              if (res.state) {
                this.$notify({
                  type: 'success',
                  message: '添加成功',
                  duration: 2000
                })
                this.showWarehouseDia = false
                this.$emit('getTreen')
                this.$emit('loadData')
              }
            })
          }
        } else {
          this.$notify({
            type: 'warning',
            message: '请完善表单信息！',
            duration: 2000
          })
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.bbsl-location-dialog {
  height: 50%;
}
</style>
